;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UrForth level 1: self-hosting 32-bit Forth compiler
;; Copyright (C) 2020 Ketmar Dark // Invisible Vector
;; GPLv3 ONLY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
use-lib: asm
get-current also os definitions


-1 constant EPERM
-2 constant ENOENT
-3 constant ESRCH
-4 constant EINTR
-5 constant EIO
-6 constant ENXIO
-7 constant E2BIG
-8 constant ENOEXEC
-9 constant EBADF
-10 constant ECHILD
-11 constant EAGAIN
-12 constant ENOMEM
-13 constant EACCES
-14 constant EFAULT
-15 constant ENOTBLK
-16 constant EBUSY
-17 constant EEXIST
-18 constant EXDEV
-19 constant ENODEV
-20 constant ENOTDIR
-21 constant EISDIR
-22 constant EINVAL
-23 constant ENFILE
-24 constant EMFILE
-25 constant ENOTTY
-26 constant ETXTBSY
-27 constant EFBIG
-28 constant ENOSPC
-29 constant ESPIPE
-30 constant EROFS
-31 constant EMLINK
-32 constant EPIPE
-33 constant EDOM
-34 constant ERANGE
-35 constant EDEADLK
-36 constant ENAMETOOLONG
-37 constant ENOLCK
-38 constant ENOSYS
-39 constant ENOTEMPTY
-40 constant ELOOP
EAGAIN constant EWOULDBLOCK
-42 constant ENOMSG
-43 constant EIDRM
-44 constant ECHRNG
-45 constant EL2NSYNC
-46 constant EL3HLT
-47 constant EL3RST
-48 constant ELNRNG
-49 constant EUNATCH
-50 constant ENOCSI
-51 constant EL2HLT
-52 constant EBADE
-53 constant EBADR
-54 constant EXFULL
-55 constant ENOANO
-56 constant EBADRQC
-57 constant EBADSLT
EDEADLK constant EDEADLOCK
-59 constant EBFONT
-60 constant ENOSTR
-61 constant ENODATA
-62 constant ETIME
-63 constant ENOSR
-64 constant ENONET
-65 constant ENOPKG
-66 constant EREMOTE
-67 constant ENOLINK
-68 constant EADV
-69 constant ESRMNT
-70 constant ECOMM
-71 constant EPROTO
-72 constant EMULTIHOP
-73 constant EDOTDOT
-74 constant EBADMSG
-75 constant EOVERFLOW
-76 constant ENOTUNIQ
-77 constant EBADFD
-78 constant EREMCHG
-79 constant ELIBACC
-80 constant ELIBBAD
-81 constant ELIBSCN
-82 constant ELIBMAX
-83 constant ELIBEXEC
-84 constant EILSEQ
-85 constant ERESTART
-86 constant ESTRPIPE
-87 constant EUSERS
-88 constant ENOTSOCK
-89 constant EDESTADDRREQ
-90 constant EMSGSIZE
-91 constant EPROTOTYPE
-92 constant ENOPROTOOPT
-93 constant EPROTONOSUPPORT
-94 constant ESOCKTNOSUPPORT
-95 constant EOPNOTSUPP
EOPNOTSUPP constant ENOTSUP
-96 constant EPFNOSUPPORT
-97 constant EAFNOSUPPORT
-98 constant EADDRINUSE
-99 constant EADDRNOTAVAIL
-100 constant ENETDOWN
-101 constant ENETUNREACH
-102 constant ENETRESET
-103 constant ECONNABORTED
-104 constant ECONNRESET
-105 constant ENOBUFS
-106 constant EISCONN
-107 constant ENOTCONN
-108 constant ESHUTDOWN
-109 constant ETOOMANYREFS
-110 constant ETIMEDOUT
-111 constant ECONNREFUSED
-112 constant EHOSTDOWN
-113 constant EHOSTUNREACH
-114 constant EALREADY
-115 constant EINPROGRESS
-116 constant ESTALE
-117 constant EUCLEAN
-118 constant ENOTNAM
-119 constant ENAVAIL
-120 constant EISNAM
-121 constant EREMOTEIO
-122 constant EDQUOT
-123 constant ENOMEDIUM
-124 constant EMEDIUMTYPE
-125 constant ECANCELED
-126 constant ENOKEY
-127 constant EKEYEXPIRED
-128 constant EKEYREVOKED
-129 constant EKEYREJECTED
-130 constant EOWNERDEAD
-131 constant ENOTRECOVERABLE
-132 constant ERFKILL
-133 constant EHWPOISON


create errno-table
  EPERM error-table-msg," EPERM"
  ENOENT error-table-msg," ENOENT"
  ESRCH error-table-msg," ESRCH"
  EINTR error-table-msg," EINTR"
  EIO error-table-msg," EIO"
  ENXIO error-table-msg," ENXIO"
  E2BIG error-table-msg," E2BIG"
  ENOEXEC error-table-msg," ENOEXEC"
  EBADF error-table-msg," EBADF"
  ECHILD error-table-msg," ECHILD"
  EAGAIN error-table-msg," EAGAIN"
  ENOMEM error-table-msg," ENOMEM"
  EACCES error-table-msg," EACCES"
  EFAULT error-table-msg," EFAULT"
  ENOTBLK error-table-msg," ENOTBLK"
  EBUSY error-table-msg," EBUSY"
  EEXIST error-table-msg," EEXIST"
  EXDEV error-table-msg," EXDEV"
  ENODEV error-table-msg," ENODEV"
  ENOTDIR error-table-msg," ENOTDIR"
  EISDIR error-table-msg," EISDIR"
  EINVAL error-table-msg," EINVAL"
  ENFILE error-table-msg," ENFILE"
  EMFILE error-table-msg," EMFILE"
  ENOTTY error-table-msg," ENOTTY"
  ETXTBSY error-table-msg," ETXTBSY"
  EFBIG error-table-msg," EFBIG"
  ENOSPC error-table-msg," ENOSPC"
  ESPIPE error-table-msg," ESPIPE"
  EROFS error-table-msg," EROFS"
  EMLINK error-table-msg," EMLINK"
  EPIPE error-table-msg," EPIPE"
  EDOM error-table-msg," EDOM"
  ERANGE error-table-msg," ERANGE"
  EDEADLK error-table-msg," EDEADLK"
  ENAMETOOLONG error-table-msg," ENAMETOOLONG"
  ENOLCK error-table-msg," ENOLCK"
  ENOSYS error-table-msg," ENOSYS"
  ENOTEMPTY error-table-msg," ENOTEMPTY"
  ELOOP error-table-msg," ELOOP"
  ENOMSG error-table-msg," ENOMSG"
  EIDRM error-table-msg," EIDRM"
  ECHRNG error-table-msg," ECHRNG"
  EL2NSYNC error-table-msg," EL2NSYNC"
  EL3HLT error-table-msg," EL3HLT"
  EL3RST error-table-msg," EL3RST"
  ELNRNG error-table-msg," ELNRNG"
  EUNATCH error-table-msg," EUNATCH"
  ENOCSI error-table-msg," ENOCSI"
  EL2HLT error-table-msg," EL2HLT"
  EBADE error-table-msg," EBADE"
  EBADR error-table-msg," EBADR"
  EXFULL error-table-msg," EXFULL"
  ENOANO error-table-msg," ENOANO"
  EBADRQC error-table-msg," EBADRQC"
  EBADSLT error-table-msg," EBADSLT"
  EBFONT error-table-msg," EBFONT"
  ENOSTR error-table-msg," ENOSTR"
  ENODATA error-table-msg," ENODATA"
  ETIME error-table-msg," ETIME"
  ENOSR error-table-msg," ENOSR"
  ENONET error-table-msg," ENONET"
  ENOPKG error-table-msg," ENOPKG"
  EREMOTE error-table-msg," EREMOTE"
  ENOLINK error-table-msg," ENOLINK"
  EADV error-table-msg," EADV"
  ESRMNT error-table-msg," ESRMNT"
  ECOMM error-table-msg," ECOMM"
  EPROTO error-table-msg," EPROTO"
  EMULTIHOP error-table-msg," EMULTIHOP"
  EDOTDOT error-table-msg," EDOTDOT"
  EBADMSG error-table-msg," EBADMSG"
  EOVERFLOW error-table-msg," EOVERFLOW"
  ENOTUNIQ error-table-msg," ENOTUNIQ"
  EBADFD error-table-msg," EBADFD"
  EREMCHG error-table-msg," EREMCHG"
  ELIBACC error-table-msg," ELIBACC"
  ELIBBAD error-table-msg," ELIBBAD"
  ELIBSCN error-table-msg," ELIBSCN"
  ELIBMAX error-table-msg," ELIBMAX"
  ELIBEXEC error-table-msg," ELIBEXEC"
  EILSEQ error-table-msg," EILSEQ"
  ERESTART error-table-msg," ERESTART"
  ESTRPIPE error-table-msg," ESTRPIPE"
  EUSERS error-table-msg," EUSERS"
  ENOTSOCK error-table-msg," ENOTSOCK"
  EDESTADDRREQ error-table-msg," EDESTADDRREQ"
  EMSGSIZE error-table-msg," EMSGSIZE"
  EPROTOTYPE error-table-msg," EPROTOTYPE"
  ENOPROTOOPT error-table-msg," ENOPROTOOPT"
  EPROTONOSUPPORT error-table-msg," EPROTONOSUPPORT"
  ESOCKTNOSUPPORT error-table-msg," ESOCKTNOSUPPORT"
  EOPNOTSUPP error-table-msg," EOPNOTSUPP"
  EPFNOSUPPORT error-table-msg," EPFNOSUPPORT"
  EAFNOSUPPORT error-table-msg," EAFNOSUPPORT"
  EADDRINUSE error-table-msg," EADDRINUSE"
  EADDRNOTAVAIL error-table-msg," EADDRNOTAVAIL"
  ENETDOWN error-table-msg," ENETDOWN"
  ENETUNREACH error-table-msg," ENETUNREACH"
  ENETRESET error-table-msg," ENETRESET"
  ECONNABORTED error-table-msg," ECONNABORTED"
  ECONNRESET error-table-msg," ECONNRESET"
  ENOBUFS error-table-msg," ENOBUFS"
  EISCONN error-table-msg," EISCONN"
  ENOTCONN error-table-msg," ENOTCONN"
  ESHUTDOWN error-table-msg," ESHUTDOWN"
  ETOOMANYREFS error-table-msg," ETOOMANYREFS"
  ETIMEDOUT error-table-msg," ETIMEDOUT"
  ECONNREFUSED error-table-msg," ECONNREFUSED"
  EHOSTDOWN error-table-msg," EHOSTDOWN"
  EHOSTUNREACH error-table-msg," EHOSTUNREACH"
  EALREADY error-table-msg," EALREADY"
  EINPROGRESS error-table-msg," EINPROGRESS"
  ESTALE error-table-msg," ESTALE"
  EUCLEAN error-table-msg," EUCLEAN"
  ENOTNAM error-table-msg," ENOTNAM"
  ENAVAIL error-table-msg," ENAVAIL"
  EISNAM error-table-msg," EISNAM"
  EREMOTEIO error-table-msg," EREMOTEIO"
  EDQUOT error-table-msg," EDQUOT"
  ENOMEDIUM error-table-msg," ENOMEDIUM"
  EMEDIUMTYPE error-table-msg," EMEDIUMTYPE"
  ECANCELED error-table-msg," ECANCELED"
  ENOKEY error-table-msg," ENOKEY"
  EKEYEXPIRED error-table-msg," EKEYEXPIRED"
  EKEYREVOKED error-table-msg," EKEYREVOKED"
  EKEYREJECTED error-table-msg," EKEYREJECTED"
  EOWNERDEAD error-table-msg," EOWNERDEAD"
  ENOTRECOVERABLE error-table-msg," ENOTRECOVERABLE"
  ERFKILL error-table-msg," ERFKILL"
  EHWPOISON error-table-msg," EHWPOISON"
error-table-end

: errno-name  ( code -- addr count )
  errno-table forth:(find-errmsg) ifnot drop s" EDUNNO" endif
;


previous set-current
